############################################################################################################################
# Name:        StickyNades v2.1a                                                                                           #
#                                                                                                                          #
# Author:      JoeyT2008                                                                                                   #
#                                                                                                                          #
# Description: Makes grenades stick to walls and players.                                                                  #
#                                                                                                                          #
#              1. When a grenade sticks to someone, it doesn't stick in the right place yet, it does stick to them though. #
#                                                                                                                          #
# Notes:       1. To make a grenade stick to yourself, aim down and throw a grenade, it will then stick to your feet.      #
#              2. The model for the nade is from TF2, no credit goes to me whatsoever.                                     #
#                                                                                                                          #
# Credits:     Creator         JoeyT2008                                                                                   #
#                                                                                                                          #
#              Idea            JoeyT2008                                                                                   #
#                                                                                                                          #
#              Help            Errant (THANKYOU SO MUCH)                                                                   #
#                              Saul (THANKYOU SO MUCH)                                                                     #
#                              Lobe (BETRAYER)                                                                             #
#                              Ajurna                                                                                      #
#                              Mattie                                                                                      #
#                              Superdave                                                                                   #
#                              Wonder                                                                                      #
#                              GODJonez                                                                                    #
#                              MBChrono                                                                                    #
#                              GLitched System                                                                             #
#                                                                                                                          #
#              Testing         Saul                                                                                        #
#                              mupet0000                                                                                   #
#                              Errant                                                                                      #
#                                                                                                                          #
#              Parent Code     Wonder (from Venjax's emote mod) - Fixed by Errant                                          #
#                                                                                                                          #
#              Nade Model      Valve                                                                                       #
#                                                                                                                          #
#              Various CMD's   Everyone on IRC                                                                             #
############################################################################################################################

import es, gamethread, vecmath, playerlib, random

info = es.AddonInfo()
info.name = "StickyNades"
info.version = "2.1a"
info.author = "JoeyT2008"
info.url = "http://forums.mattie.info/cs/forums/viewtopic.php?t=17799"
info.description = "Allows grenades to stick to walls and players!"
info.basename = "stickynades"

######################
##START EDITING HERE##
######################

grenades = ["hegrenade", "flashbang"]
thrown = {}
stuck = {}

# Make frag grenades stick? 1=YES, 0=NO
sn_fragsticky = es.ServerVar("sn_fragsticky", 1, "Makes frag grenades stick")

# Make flashbags stick? 1=YES, 0=NO
sn_flashsticky = es.ServerVar("sn_flashsticky", 1, "Makes flashbangs stick")

# Make grenades stick to walls? 1=YES, 0=NO
sn_sticktowalls = es.ServerVar("sn_sticktowalls", 1, "Makes grenades stick to walls")

# Make grenades stick to players? 1=YES, 0=NO
sn_sticktoplayers = es.ServerVar("sn_sticktoplayers", 1, "Makes grenades stick to players")

# Make grenades stick to the thrower? 1=YES, 0=NO
sn_sticktothrower = es.ServerVar("sn_sticktothrower", 0, "Makes grenades stick to the thrower")

# Play sounds when a player gets stuck? 1=YES, 0=NO
sn_emitsounds = es.ServerVar("sn_emitsounds", 1, "Plays sounds when a player gets stuck")

# Force players to download models, materials and sounds? 1=YES, 0=NO
sn_downloads = es.ServerVar("sn_downloads", 1, "Forces players to download models, materials and sounds")

# Use a custom model for frag grenades? 1=YES, 0=NO
sn_newmodel = es.ServerVar("sn_newmodel", 1, "Uses a custom model for frag grenades")

# Power of a frag grenade when not stuck to a player. (Real damage = 100)
sn_grenadenormalpower = es.ServerVar("sn_grenadenormalpower", 100, "Power of a frag grenade when not stuck to a player")

# Power of a frag grenade when stuck to a player. (Real damage = 100)
sn_grenadestuckpower = es.ServerVar("sn_grenadestuckpower", 300, "Power of a frag grenade when stuck to a player")

# Radius of a frag grenade when not stuck to a player. (Real radius = 350)
sn_grenadenormalradius = es.ServerVar("sn_grenadenormalradius", 350, "Radius of a frag grenade when not stuck to a player")

# Radius of a frag grenade when stuck to a player. (Real radius = 350)
sn_grenadestuckradius = es.ServerVar("sn_grenadestuckradius", 350, "Radius of a frag grenade when stuck to a player")

# Shake when hit by a stickynade?
sn_shake = es.ServerVar("sn_shake", 1, "Shakes screen when hit by a stickynade")

#####################
##STOP EDITING HERE##
#####################

stickynades_ver = es.ServerVar("stickynades_ver", info.version, "Version of StickyNades that you are using.")
stickynades_ver.makepublic()

def load():
    if not es.ServerVar("eventscripts_currentmap") == "":
        downloads()
    stickyloop()

def unload():
    gamethread.cancelDelayed("stickyloop")

def es_map_start(event_var):
    gamethread.cancelDelayed("stickyloop")
    stickyloop()
    downloads()

def downloads():
    files = ["sound/stickynades/muhahaha.wav", "sound/stickynades/scream.wav", "models/stickynades/stickynades_red.dx80.vtx", "models/stickynades/stickynades_red.dx90.vtx", "models/stickynades/stickynades_red.mdl", "models/stickynades/stickynades_red.phy", "models/stickynades/stickynades_red.sw.vtx", "models/stickynades/stickynades_red.vvd", "models/stickynades/stickynades_blue.dx80.vtx", "models/stickynades/stickynades_blue.dx90.vtx", "models/stickynades/stickynades_blue.mdl", "models/stickynades/stickynades_blue.phy", "models/stickynades/stickynades_blue.sw.vtx", "models/stickynades/stickynades_blue.vvd", "materials/models/stickynades/stickynades_blue.vtf", "materials/models/stickynades/stickynades_blue.vmt", "materials/models/stickynades/stickynades_red.vtf", "materials/models/stickynades/stickynades_red.vmt"]
    for file in files:
        es.stringtable('downloadables', file)

def round_start(event_var):
    global stuck
    es.msg("#multi", "#green[StickyNades]#lightgreen is running. Created by #greenJoeyT2008")
    if sn_fragsticky == 1:
        if sn_sticktowalls == 1:
            if sn_sticktoplayers == 1:
                es.msg("#multi", "#green[StickyNades]#lightgreen Frag Grenades stick to walls and players.")
            else:
                es.msg("#multi", "#green[StickyNades]#lightgreen Frag Grenades stick to walls.")
        else:
            if sn_sticktoplayers == 1:
                es.msg("#multi", "#green[StickyNades]#lightgreen Frag Grenades stick to players.")
    if sn_flashsticky == 1:
        if sn_sticktowalls == 1:
            if sn_sticktoplayers == 1:
                es.msg("#multi", "#green[StickyNades]#lightgreen Flashbangs stick to walls and players.")
            else:
                es.msg("#multi", "#green[StickyNades]#lightgreen Flashbangs stick to walls.")
        else:
            if sn_sticktoplayers == 1:
                es.msg("#multi", "#green[StickyNades]#lightgreen Flashbangs stick to players.")

def stickyloop():
    global thrown
    for grenade in grenades:
        for index in es.createentitylist("%s_projectile" % grenade):
            stop = 0
            for userid in thrown:
                for num in thrown[userid]:
                    if thrown[userid][num][0] == index:
                        stop = 1
            if stop == 0:
                userid = es.getuserid(es.getindexprop(index, "CBaseGrenade.m_hThrower"))
                grenadecheck(index, 1)
                if grenade == "hegrenade":
                    if sn_newmodel == 1:
                        if es.getplayerteam(userid) == 2:
                            es.setindexprop(index, "CBaseEntity.m_nModelIndex", es.precachemodel("models/stickynades/stickynades_red.mdl"))
                        if es.getplayerteam(userid) == 3:
                            es.setindexprop(index, "CBaseEntity.m_nModelIndex", es.precachemodel("models/stickynades/stickynades_blue.mdl"))
                        es.setindexprop(index, "CBaseEntity.m_clrRender", -1)
                if not userid in thrown:
                    thrown[userid] = {}
                num = len(thrown[userid])+1
                thrown[userid][num] = {}
                thrown[userid][num][0] = index
                thrown[userid][num][1] = grenade
    entitylist = []
    for grenade in grenades:
        for index in es.createentitylist("%s_projectile" % grenade):
            entitylist.append(index)
    deleted = []
    for userid in thrown:
        for num in thrown[userid]:
            if not thrown[userid][num][0] in entitylist:
                deleted.append(num)
    for num in deleted:
        if num in thrown[userid]:
            del thrown[userid][num]
    gamethread.delayedname(0.1, "stickyloop", stickyloop)

def grenade_bounce(event_var):
    global thrown
    index = None
    if int(event_var["userid"]) in thrown:
        deleted = []
        for num in thrown[int(event_var["userid"])]:
            if thrown[int(event_var["userid"])][num][1] in grenades:
                index = thrown[int(event_var["userid"])][num][0]
                deleted.append(num)
        for num in deleted:
            if num in thrown[int(event_var["userid"])]:
                del thrown[int(event_var["userid"])][num]
    if not index == None:
        if sn_sticktowalls == 1:
            es.setindexprop(index, "CBaseEntity.movetype", 0)
        inrange(es.getindexprop(index, "CBaseEntity.m_vecOrigin"), 80, playerlib.getPlayerList('#all'), event_var["userid"], index)

def inrange(location, radius, playerlist, userid, index):
    nearid = None
    lowestradius = 50000
    for targetid in playerlist:
        if (not int(targetid.attributes['isdead'])) and int(targetid.attributes['teamid'])>1:
                targetlocation = vecmath.vector((targetid.attributes['x'], targetid.attributes['y'], targetid.attributes['z']))
                distance = vecmath.distance(targetlocation, location)
                if distance <= lowestradius:
                    lowestradius = distance
                    nearid = targetid
    if not nearid == None:
        if lowestradius <= radius:
            stick(int(userid), int(nearid), index)

def shake(userid, magnitude, time):
    if es.exists('userid', userid):
        es.usermsg('create', 'shake', 'Shake')
        es.usermsg('write', 'byte', 'shake', 0)
        es.usermsg('write', 'float', 'shake', magnitude)
        es.usermsg('write', 'float', 'shake', 1.0)
        es.usermsg('write', 'float', 'shake', time)
        es.usermsg('send', 'shake', userid)
        es.usermsg('delete','shake')

def stick(userid, nearid, index):
    if sn_sticktoplayers == 1:
        type = None
        for grenade in grenades:
            for checkindex in es.createentitylist("%s_projectile" % grenade):
                if checkindex == index:
                    type = grenade
        if not type == None:
            username = es.getplayername(userid)
            nearname = es.getplayername(nearid)
            es.setindexprop(index, "CBaseEntity.movetype", 0)
            if type == "hegrenade":
                grenadecheck(index, 2)
                if userid == nearid:
                    if sn_sticktothrower == 1:
                        es.msg("#multi", "#green[StickyNades]#lightgreen%s#default stuck himself with a #lightgreenFrag Grenade#default!" % username)
                else:
                    es.msg("#multi", "#green[StickyNades]#lightgreen%s#default stuck#lightgreen %s#default with a #lightgreenFrag Grenade#default!" % (username, nearname))
            if type == "flashbang":
                if userid == nearid:
                    if sn_sticktothrower == 1:
                        es.msg("#multi", "#green[StickyNades]#lightgreen%s#default stuck himself with a #lightgreenFlashbang#default!" % username)
                else:
                    es.msg("#multi", "#green[StickyNades]#lightgreen%s#default stuck#lightgreen %s#default with a #lightgreenFlashbang#default!" % (username, nearname))
            if sn_emitsounds == 1:
                if not userid == nearid:
                    es.emitsound("player", userid, "stickynades/muhahaha.wav", 1, 0.5)
                    es.emitsound("player", nearid, "stickynades/scream.wav", 1, 0.5)
                else:
                    if sn_sticktothrower == 1:
                        es.emitsound("player", userid, "stickynades/scream.wav", 1, 0.5)
            if sn_shake == 1:
                if not userid == nearid:
                    shake(nearid, 50, 1)
                else:
                    if sn_sticktothrower == 1:
                        shake(userid, 50, 1)
            if userid == nearid and sn_sticktothrower == 1 or not userid == nearid:
                nade = "nade" + str(nearid)
                if es.exists("variable", "est_version"):
                    es.server.cmd("est_setentname %d %s" % (index, nade))
                else:
                    es.server.cmd("setentname %d %s" % (index, nade))
                user = "user" + str(nearid)
                es.server.cmd('es_fire %s !self addoutput "targetname %s"' % (nearid, user))
                es.server.cmd("es_fire %s %s SetParent %s" % (nearid, nade, user))
                es.server.cmd("es_fire %s %s SetAnimation idle" % (nearid, nade))
                es.server.cmd('es_fire %s %s addoutput "angles 0 0 0"' % (nearid, nade))
                es.server.cmd('es_fire %s %s addoutput "solid 0"' % (nearid, nade))
                es.server.cmd("es_fire %s %s FireUser1" % (nearid, nade))

def grenadecheck(index, type):
    if type == 1:
        power = sn_grenadenormalpower
        radius = sn_grenadenormalradius
    if type == 2:
        power = sn_grenadestuckpower
        radius = sn_grenadestuckradius
    if index in es.createentitylist():
        es.setindexprop(index, "CBaseGrenade.m_flDamage", power)
        es.setindexprop(index, "CBaseGrenade.m_DmgRadius", radius)
        gamethread.delayed(0.1, grenadecheck, (index, type))